! F2003 access control

module f2003_access
  implicit none
  PRIVATE

  PUBLIC    :: print_age
  PUBLIC    :: person
  PUBLIC    :: douglas

  type person
     character(32), PUBLIC  :: name
     integer,       PRIVATE :: age
  end type person

  type(person), PROTECTED :: douglas = person ("Douglas Adams", 42)

contains

  subroutine print_age (p)
    type(person), intent(in) :: p
    print *, trim (p% name), "'s age is", p% age
  end subroutine print_age

end module f2003_access

program main
  use f2003_access, only : print_age, douglas
  implicit none
  call print_age (douglas)
end program main
