program f2003_pointer_intent
  implicit none
  integer, pointer   :: k(:)

  allocate (k(1))
  k = 2
  call sub (k)
  if (k(1) == 3) then
     print *, "OK"
  else
     print *, "Bug"
     stop
  end if
  deallocate (k)

contains

  subroutine sub (p)
    integer, pointer, intent(in) :: p(:)

    p(1) = 3            ! May modify pointee!
  end subroutine sub

end program f2003_pointer_intent
