program f2003_import
  implicit none
  integer, parameter :: wp = kind (1.d0)
  real(wp) :: y

  interface
     subroutine foo (x)
       import   :: wp
       implicit none
       real(wp) :: x
     end subroutine foo
  end interface

  y = 1.d0
  call foo (y)
  if (y /= -2.d0) then
     print *, "Bug!"
  else
     print *, "OK"
  end if
end program f2003_import

subroutine foo (x)
  implicit none
  double precision :: x
  x = -2.d0
end subroutine foo
