! Pointer assignment and remapping of pointers to rank 1 arrays

program f2003_pointer_rank
  integer :: i
  integer, pointer   :: j(:), k(:,:), m(:,:)
  integer, parameter :: n1 = 2, n2 = 3

  allocate (j(n1*n2))
  j = [ (i, i=1,size (j)) ]

  k(1:n1,1:n2) => j(1:n1*n2)
  print *, "shape (j) =", shape (j)
  print *, "shape (k) =", shape (k)
  if (k(n1,n2) /= n1*n2) then
     print *, "Remapping error!"
     stop
  end if

  m(0:,-1:) => k
  print *, "shape (m) =", shape (m)
  print *, "lbound(m) =", lbound (m)
  print *, "ubound(m) =", ubound (m)
  if (m(n1-1,n2-2) /= n1*n2) then
     print *, "Assignment error!"
     stop
  end if
end program f2003_pointer_rank
